# Список изменений в индикаторе VP

## 9.0 (2020-03-02)

- исправлено: не находятся моды, расположенные близко к краям, #19
- добавлен параметр Quantiles для отображения некоторых квантилей, включая медиану, вместо только медианы, параметр MedianColor переименован QuantileColor
- добавлен параметр HgColoring - способ расцветки гистограмм
- добавлен параметр StatLineWidth - толщина линий статистики (VWAP, квантили), раньше была общей с толщиной мод
- при Bar Style = Color если оба цвета одинаковы, то первый считается прозрачным
- добавлен обязательный временной зазор между обновлениями (500 мс)

## 8.3 (2019-12-07)

- исправлено: неверное отображение значений параметров Mode, RangeMode, HgPosition, #42
- исправлено: смещение гистограмм при появлении нового бара, #41

## 8.2 (2019-10-21)

- нулевые хвосты обрезаются, особенно актуально при сглаживании и использовании типов отображения "контур" и "цвет", #28

## 8.1 (2019-10-20)

- исправлено: небольшая ошибка сглаживания на концах гистограмм, #29
- исправлено: не показываются моды и их уровни в режиме диапазона, #30
- исправлено: не работает VWAP, экран заливается красным, #31

## 8.0 (2019-10-18=)

- исправлено: размер последней гистограммы выходит за данные, #26
- исправлено: потеря точности при вычислении и отображении, #27
- добавлен параметр TickPriceType для явного указания типа цены тиков, а также параметры их фильтрации: TickBid, TickAsk, TickLast, TickVolume, TickBuy, TickSell, #25
- улучшен контроль за загрузкой отсутствующих данных
- HgWidthPercent заменён на новый параметр HgWidthPct: процент нормальной ширины гистограммы (100% для периодов и 15% для диапазона, кроме отображения внутри), #8
- режимы автомасштаба separate и overall переименованы в local и global соответственно
- учёт цвета в режиме автомасштаба global, #24

## 7.2 (2019-10-04)

- исправлено: неверно рассчитывались границы для периодов меньше D1, fix #15
- исправлено: не работает, если комбинация параметров приводит к шагу гистограммы больше 1
- исправлено: при тиковых исходных данных отсутствие фильтрации данных приводит к очень медленной работе, fix #22
- не используется информация с таймфрейма RangePeriods, меньше ошибок из-за использования множества таймфреймов
- гистограммы не перепрыгивают большие разрывы (выходные, праздники, в режиме разбивки)
- при сглаживании не обрезаются хвосты
- в режиме Outline хвосты замыкаются на ноль
- уточнение названия параметра: Time Shift -> Time Zone Shift
- позиции `Window left` и `Widow right` переименованы в `Chart left` и `Chart right` соответственно
- ускорен расчёт гистограмм за счёт снижения числа обращений к ценовой истории и оптимизации кода
- установлен таймер на максимальное непрерывное время работы в режиме разбивки на периоды
- старые, смещённые новым периодом гистограммы удаляются, чтобы на графике было только заданное их число
- снижена частота запроса истории при её отсутствии при прошлом запросе

## 7.1 (2019-08-30)

- исправлено: в режиме диапазона при использовании опции сглаживания Smooth гистограмма съезжает вниз на степень сглаживания, fix #18
- исправлено: не рисуется последняя гистограмма, если период равен таймфрейму, fix #17

## 7.0 (2019-04-01)

- VP и VP-Range объединены в один индикатор VP, переключение параметром Mode
- улучшены подсказки
- ZoomType, ZoomCustom: тип масштабирования гистограмм: пользовательский (одинаковый для всех), авто (отдельно для каждой), авто (для всех в целом)
- исправлено: не удаляются старые гистограммы (левее первой), может быть актуально для экономии ресурсов в визуальном тестере (Period Mode)
- в 5 расширен набор источников данных (DataSource), добавлены промежуточные таймфреймы M2, M3 и подобные
- ShowHorizon: показывать горизонт данных
- ModeLevelWidth: толщина линий уровней мод (Range Mode)
- HgWidthPercent (Range Mode): ширина гистограммы в процентах от ширины графика
- Smooth: сглаживание
- убран параметр VolumeType в 4, т.к. бесполезен

## 6.1 (2018-07-09)

- совместимость с MT5 билд 1845 (где добавлены iTime, iBarShift)

## 6.0 (2016-04-18)

- добавлено: новый параметр "Data source" для указания источника данных - таймфреймы M1, M5, M15 или (только в MT5) тики.
- изменено: параметр "Point scale" перенесён выше в списке параметров
- изменено: параметр "Bar style" перенесён выше в списке параметров

## 5.8 (2016-04-13)

- исправлено: гистограмма не отображается, если есть хотя бы один бар с нулевым объёмом на таймфрейме источника данных

## 5.7 (2016-03-28)

- VP:
	- исправлено: при "Range period" = "1 Week" гистограммы смещались на день влево

## 5.6 (2016-02-08)

- VP-Range:
	- исправлено: не обновляется гистограмма в режиме "Last minutes"
	- исправлено: не учитывается последняя минута в режиме "Last minutes"

## 5.5 (2016-02-04)

- изменены ссылки на сайт
- список изменений в коде

## 5.4 (2016-01-30)

- исправлена медиана в MT4

## 5.3 (2016-01-28)

- исправлено: в MT4 при рисовании пустыми прямоугольниками плохо было видно моды из-за наложения баров
- стиль баров по умолчанию изменён на линии

## 5.2 (2016-01-24)

- VP-Range:
	- исправлено: в режиме "Minutes to line" не выделяется правая граница, но выделяется левая, должно быть наоборот
	- исправлено: после переключения режима с "Minutes to line" на "Between lines" не выделяется одна из границ

## 5.1 (2016-01-21)

- исправлено игнорирование отображения на определённых таймфреймах в MT4 (обход бага в MT4)

## 5.0 (2016-01-17)

- увеличены таймауты перерисовки для снижения нагрузки
- только VP:
	- временной сдвиг от -12 до +12 часов с шагом 1 час для компенсации сдвига часового пояса у брокера
	- по умолчанию медиана и VWAP выключены

## 4.0 (2016-01-12)

- индикатор переименован на VP (сокращение от Volume Profile)
- добавлена версия для MetaTrader 5 с минимальными отличиями в коде от версии для MetaTrader 4
- добавлено: второй цвет гистограммы для рисования градиентом
- добавлено: типы гистограмм Outline (контур) и Color (цвет)
- добавлено: уровни VWAP (средневзвешенная по объёму цена) и Median (медиана)
- добавлено: ручное указание масштаба пункта
- добавлено: VP-Range: расположение гистограммы внутри диапазона
- добавлено: VP: отображение гистограмм справа налево
- изменено: Mode step теперь следует указывать в 10 раз больше для того же результата, это сделано для большей точности на небольших диапазонах
- изменено: VP: данные последнего бара теперь учитываются
- изменено: VP-Range: в режимах отображения от границ окна и границ диапазона наружу ширина гистограммы увеличена с 10% до 15% от размеров графика, в остальных случаях (внутри границ диапазона) ширина равна ширине диапазона

## 3.2 (2016-01-02)

- исправлено: при открытии на графике без истории появляется ошибка "...array out of range in..."
- изменено: линия горизонта спрятана из списка объектов и отключена для выбора

## 3.1 (2015-12-28)

- исправлено: при обновлении по последним данным могут оставаться старые моды и максимумы
- добавлено: TPO-Range теперь обновляется сразу после перемещения границ в соответствущих режимах

## 3.0 (2014-02-22)

- скрыты недокументированные параметры DataPeriod и PriceStep (были показаны по ошибке)
- использование новых возможностей MetaTrader 4 и оптимизация под него:
	- улучшены отображаемые названия параметров
	- перечисляемые параметры (режимы, стили, периоды) реализованы в виде списков выбора, их числовые значения остались прежними
	- линии гистограмм нельзя выбрать мышкой (не мешаются среди других индикаторов и разметки)
	- оптимизация после изменений в работе функции ArrayCopyRates()
	- поддержка реальных объемов, если они доступны
- исправлен параметр ModeStep, теперь он лучше реагирует на изменения
- удаление за собой линий диапазона в TPO-Range, в одном из предыдущих обновлений MetaTrader исправлена ошибка, мешающая делать это
- удалена скрытая поддержка нескольких методов имитации тиков, оставлен только наиболее точный
- в режиме 1 (Last minutes) TPO-Range линии выбора/отображения диапазона больше не показываются

## 2.6 (2014-02-15)

- совместимость с MetaTrader версии 4.00 Build 600 и новее

## 2.5.7491

- в некоторых режимах в стиле по умолчанию (HGStyle=1) при сжатии графика по вертикали исчезает изображение локальных максимумов
- удалено из-за ошибки в МТ: TPO-Range - при удалении индикатора удаляются и линии границ (было добавлено в 2.4.7290)

## 2.5.7484

- в стиле по умолчанию (HGStyle=1) при сжатии графика по вертикали исчезает изображение локальных максимумов

## 2.5.7473

- названия индикаторов изменены в соответствии с распространённым названием методики расчёта, схожей с данной
- добавлен параметр HGStyle: 0 - рисовать линиями, 1 - рисовать пустыми прямоугольниками (значение по умолчанию), 2 - обычные прямоугольники (режим полезен при наложении нескольких индикаторов TPO друг на друга)

## 2.4.7290

- исправлено: не удаляются старые моды при использовании на меняющихся данных
- из набора исключён скрипт +FindVL
- исправлено: при включенной максимальной моде и отключенных остальных показываются все
- +VL - при удалении индикатора удаляются и линии границ

## 2.3.6704

- полностью убран режим работы через vlib2.dll
- исправлено: при отключенных модах, но включенной максимальной, максимальная не рисовалась
- +MP - показ максимальной моды по умолчанию отключен
- исправлено: +VL - при отключенных модах, но включенных уровнях, уровни не рисовались

## 2.2.6294

- режим работы без vlib2.dll
- убраны лишние методы поиска мод
- параметр Smooth переименован в ModeStep
- код из +mpvl.mqh перенесен в основные файлы (упрощение установки и распространения)

## 2.1

- исправлено: ошибка в расчетах
- убраны лишние методы расчета (скрытый параметр TickMethod)
- исправлено: автоопределение масштаба Smooth при работе на пятизнаке
- добавлены опции в скрипте +FindVL

## 2.0

- существенно увеличена скорость работы
- оптимизирован набор параметров

## 1-18 (1.1-1.18)

- тестовые версии, различающиеся по функционалу и параметрам
